package be.iminds.ilabt.jfed.restapi.jfedclient;

import be.iminds.ilabt.jfed.experiment.Experiment;
import be.iminds.ilabt.jfed.experiment.ExperimentController;
import be.iminds.ilabt.jfed.experiment.ExperimentState;
import be.iminds.ilabt.jfed.highlevel.model.Slice;
import be.iminds.ilabt.jfed.log.Logger;
import be.iminds.ilabt.jfed.lowlevel.GeniUser;
import be.iminds.ilabt.jfed.lowlevel.TestbedInfoSource;
import be.iminds.ilabt.jfed.lowlevel.api_wrapper.StatusDetails;
import be.iminds.ilabt.jfed.lowlevel.authority.AuthorityFinder;
import be.iminds.ilabt.jfed.restapi.debugdata.ClientApiCallDDCollector;
import be.iminds.ilabt.jfed.util.GeniUrn;
import be.iminds.ilabt.jfed.util.JFedTrustStore;

import javax.xml.namespace.QName;
import java.sql.Timestamp;
import java.time.Instant;
import java.util.List;

/**
 * JFedExperimenterApi
 */
public interface JFedExperimenterApi {
    QName Q_BUGREPORT = new QName("bugreport");
    QName Q_CALLS = new QName("calls");
    QName Q_CALL = new QName("call");

    Logger getLogger();

    GeniUser getUser();

    TestbedInfoSource getTestbedInfoSource();

    AuthorityFinder getAuthorityFinder();

    JFedTrustStore getJFedTrustStore();

    boolean removeClientApiCallDDCollector(ClientApiCallDDCollector clientApiCallDDCollector);

    void addClientApiCallDDCollector(ClientApiCallDDCollector clientApiCallDDCollector);

    void setClientApiCallDDCollector(ClientApiCallDDCollector clientApiCallDDCollector);

    List<GeniUrn> getProjectsForUser(GeniUrn user);

    List<GeniUrn> getSlicesForUser(GeniUrn user);

    void createSliceAndSlivers(String sliceName, String project, String rspec, Instant expire);

    void refreshStatusIfNeeded();

    void recoverSlice(GeniUrn sliceUrn);

    void renewSlice(Timestamp newExpire);

    void deleteSlice();

    String getProject();

    String getSliceName();

    GeniUrn getSliceUrn();

    Timestamp getExpire();

    String getManifestRspec();

    Slice getExperimentSlice();

    StatusDetails getExperimentSliceStatus();

    Experiment getExperiment();

    ExperimentState getExperimentState();

    ExperimentController getExperimentController();
}
